<template>
  <div class="app-container">
    <el-form v-show="showSearch" ref="queryForm" :inline="true" :model="queryParams" label-width="68px">
      <el-form-item label="岗位" prop="usePost">
        <el-select v-model="queryParams.usePost" clearable placeholder="请选择应配备岗位" size="small">
          <el-option
              v-for="dict in usePostOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="PPE种类" prop="ppeType">
        <el-input
            v-model="queryParams.ppeType"
            clearable
            placeholder="请输入PPE种类"
            size="small"
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button icon="el-icon-search" size="mini" type="cyan" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
            icon="el-icon-plus"
            size="mini"
            type="primary"
            @click="handleAdd"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            :disabled="single"
            icon="el-icon-edit"
            size="mini"
            type="success"
            @click="handleUpdate"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            :disabled="multiple"
            icon="el-icon-delete"
            size="mini"
            type="danger"
            @click="handleDelete"
        >删除
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="matrixList" :height="clientHeight"
              :span-method="mergeMethod" border @selection-change="handleSelectionChange">
      <el-table-column align="center" type="selection" width="55"/>
      <el-table-column :formatter="usePostFormat" align="center" label="岗位" prop="usePost"/>
      <el-table-column :show-overflow-tooltip="true" align="center" label="PPE种类" prop="ppeType"/>
      <el-table-column :formatter="personFormat" :show-overflow-tooltip="true" align="center" label="指定人"
                       prop="assigner"/>
      <el-table-column align="center" class-name="small-padding fixed-width" label="操作">
        <template slot-scope="scope">
          <el-button
              icon="el-icon-edit"
              size="mini"
              type="text"
              @click="handleUpdate(scope.row)"
          >修改
          </el-button>
          <el-button
              icon="el-icon-delete"
              size="mini"
              type="text"
              @click="handleDelete(scope.row)"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
        v-show="total>0"
        :limit.sync="queryParams.pageSize"
        :page-sizes="[20,50,100]"
        :page.sync="queryParams.pageNum"
        :total="total"
        @pagination="getList"
    />

    <!-- 添加或修改ppe矩阵管理对话框 -->
    <el-dialog :title="title" :visible.sync="open" append-to-body width="500px">
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="PPE种类" prop="ppeType">
          <el-input v-model="form.ppeType" placeholder="请输入PPE种类"/>
        </el-form-item>
        <el-form-item label="应配备岗位" prop="usePost">
          <el-select v-model="form.usePost" placeholder="请选择应配备岗位">
            <el-option
                v-for="dict in usePostOptions"
                :key="dict.dictValue"
                :label="dict.dictLabel"
                :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="是否指定人" prop="isAssigner">
          <el-checkbox v-model="form.isAssigner">是否指定人？</el-checkbox>
        </el-form-item>
        <el-form-item v-if="form.isAssigner" label="指定人" prop="assigner">
          <el-select v-model="form.assigner" clearable filterable multiple placeholder="请选择指定人">
            <el-option
                v-for="dict in personOptions"
                :key="dict.dictValue"
                :label="dict.dictLabel+'_'+dict.dictValue"
                :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  addMatrix,
  delMatrix,
  exportMatrix,
  getMatrix,
  importTemplate,
  listMatrix,
  updateMatrix
} from "@/api/production/matrix";
import {treeselect} from "@/api/system/dept";
import {getToken} from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {listAllPerson} from "@/api/production/person";

export default {
  name: "Matrix",
  components: {Treeselect},
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // ppe矩阵管理表格数据
      matrixList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight: 300,
      // 是否显示弹出层
      open: false,
      // 应配备岗位字典
      usePostOptions: [],
      personOptions: [],
      // 用户导入参数
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/production/matrix/importData"
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 100,
        ppeType: null,
        usePost: null,
        assigner: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        remarks: null,
        deptId: null,
        isAssigner: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        assigner: [
          {required: true, message: "指定人不能为空", trigger: "blur"}
        ],
        usePost: [
          {required: true, message: "岗位不能为空", trigger: "blur"}
        ],
        ppeType: [
          {required: true, message: "PPE种类不能为空", trigger: "blur"}
        ],
      }
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  created() {
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = document.body.clientHeight - 250
    })
    this.getList();
    this.getTreeselect();
    this.getDicts("PPE_POST").then(response => {
      this.usePostOptions = response.data;
    });
    listAllPerson({}).then(res => {
      res.data.forEach(item => {
        this.personOptions.push({dictValue: item.employeeid, dictLabel: item.name})
      })
    })
  },
  methods: {
    /** 查询ppe矩阵管理列表 */
    getList() {
      this.loading = true;
      listMatrix(this.queryParams).then(response => {
        this.matrixList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    // 应配备岗位字典翻译
    usePostFormat(row, column) {
      return this.selectDictLabel(this.usePostOptions, row.usePost);
    },
    // 指定人字典翻译
    personFormat(row, column) {
      return this.selectDictLabels(this.personOptions, row.assigner, ',');
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        ppeType: null,
        usePost: null,
        assigner: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        remarks: null,
        deptId: null,
        isAssigner: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加ppe矩阵管理";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getMatrix(id).then(response => {
        if (response.data.assigner)
          response.data.assigner = response.data.assigner.split(',')
        response.data.isAssigner == '1' ? response.data.isAssigner = true : false;
        this.form = response.data;
        this.open = true;
        this.title = "修改ppe矩阵管理";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.assigner)
            this.form.assigner = this.form.assigner.join(',')
          if (this.form.isAssigner) {
            this.form.isAssigner = '1';
          }
          if (this.form.id != null) {
            updateMatrix(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addMatrix(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delMatrix(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有ppe矩阵管理数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return exportMatrix(queryParams);
      }).then(response => {
        this.download(response.msg);
      })
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "用户导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      importTemplate().then(response => {
        this.download(response.msg);
      });
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", {dangerouslyUseHTMLString: true});
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },

    //合并单元格
    mergeMethod({row, column, rowIndex, columnIndex}) {
      // console.log(row)
      if (columnIndex === 1) {
        const _row = this.setTable(this.matrixList).merge[rowIndex];
        const _col = _row > 0 ? 1 : 0;
        return {
          rowspan: _row,
          colspan: _col
        };
      }
    },
    //单元格整理
    setTable(tableData) {
      //    console.log(tableData)
      let spanArr = [],
          concat = 0;
      tableData.forEach((item, index) => {
        if (index === 0) {
          spanArr.push(1);
        } else {
          if (item.usePost === tableData[index - 1].usePost) {
            //第一列需合并相同内容的判断条件
            spanArr[concat] += 1;
            spanArr.push(0);
          } else {
            spanArr.push(1);
            concat = index;
          }
        }
      });
      return {
        merge: spanArr
      };
    },
  }
};
</script>
